
#include <Pilot.h>
#include "pocketth.h"
#include "hackuidef.h"
#include "thai.h"

Word myFntWordWrap (Char * const chars, const Word maxWidth)
{
	DWord			value;
    Word			(*oldTrap)(Char * const, const Word);	
	Word			i, newWidth, newLen, maxChars, charsLen, maxLen;
	Char *			chptr;
	Boolean		haveThaiToneChar;
	unsigned char uChar;

	//	Get the old trap address from HackMaster.
	FtrGet (MYCRID, trapIDFntWordWrap, &value);
    oldTrap = (Word (*)(Char * const, const Word)) value;

	maxChars = oldTrap(chars, maxWidth);
	charsLen = StrLen(chars);
	chptr = StrChr(chars, chrLineFeed);

	if (chptr != NULL) {
		maxLen = chptr - chars + 1;
		if (maxLen > maxChars) {

			newWidth = 0;
			newLen = 0;
			haveThaiToneChar = false;

			for (i = 0; i < maxLen; i++)
			{
				uChar = (unsigned char) chars[i];
				switch (uChar) {
				case HunAkad:
				case SaraIe:
				case SaraE:
				case SaraUe:
				case SaraUee:
				case SaraU:
				case SaraUU:
				case ThaiDot:
				case MaiTaiKuu:
				case MaiEk:
				case MaiToe:
				case MaiTri:
				case MaiJattawa:
				case Karan:
				case ThaiSpecial1:
				case ThaiSpecial2:
					haveThaiToneChar = true;
					break;
				default:
					newWidth += FntCharWidth(chars[i]);
				}
				if (newWidth < maxWidth) {
					newLen++;
				} else {
					break;
				}
			} // end for

			if ( haveThaiToneChar ) {

				uChar = (unsigned char) chars[newLen];
				switch (uChar) {
				case SaraAh:
				case SaraR:
				case SaraUm:
				case SaraR2:
				case MaiYamok:
					newLen--;
					break;
				}

				uChar = (unsigned char) chars[newLen-1];
				switch (uChar) {
				case SaraA:
				case SaraAir:
				case SaraO:
				case MaiMuan:
				case MaiMalai:
					newLen--;
					break;
				}

				maxChars = newLen;

			}

		} // end if maxLen > maxChars
	} else { //end if chptr != NULL

		// if chptr == NULL
		maxLen = charsLen;
		if (maxLen > maxChars) {

			newWidth = 0;
			newLen = 0;
			haveThaiToneChar = false;

			for (i = 0; i < maxLen; i++)
			{
				uChar = (unsigned char) chars[i];
				switch (uChar) {
				case HunAkad:
				case SaraIe:
				case SaraE:
				case SaraUe:
				case SaraUee:
				case SaraU:
				case SaraUU:
				case ThaiDot:
				case MaiTaiKuu:
				case MaiEk:
				case MaiToe:
				case MaiTri:
				case MaiJattawa:
				case Karan:
				case ThaiSpecial1:
				case ThaiSpecial2:
					haveThaiToneChar = true;
					break;
				default:
					newWidth += FntCharWidth(chars[i]);
				}
				if (newWidth < maxWidth) {
					newLen++;
				} else {
					break;
				}
			} // end for

			if ( haveThaiToneChar ) {

				uChar = (unsigned char) chars[newLen];
				switch (uChar) {
				case SaraAh:
				case SaraR:
				case SaraUm:
				case SaraR2:
				case MaiYamok:
					newLen--;
					break;
				}

				uChar = (unsigned char) chars[newLen-1];
				switch (uChar) {
				case SaraA:
				case SaraAir:
				case SaraO:
				case MaiMuan:
				case MaiMalai:
					newLen--;
					break;
				}

				maxChars = newLen;

			}
		} // end if maxLen > maxChars
	}

	return maxChars;
	//	Done!

}