
#include <Pilot.h>
#include "pocketth.h"
#include "hackuidef.h"

// from SystemPrv.h
typedef struct SysAppInfoType {
	Int				cmd;						// command code for app
	Ptr				cmdPBP;						// cmd ParamBlock  
	UInt			launchFlags;				// launch flags  
	
	Long			taskID;						// AMX task ID of task that app runs in
	Handle			codeH;						// code handle of the main code segment
	DmOpenRef		dbP;						// Application database access ptr of App
	Ptr				stackP;						// stack chunk for the App
	Ptr				globalsChunkP;				// globals chunk for the App

	UInt			memOwnerID;					// owner ID for Memory Manager chunks 
	Ptr				dmAccessP;					// pointer to linked list of opened DB's
	SWord			dmLastErr;					// Last error from Data Manager
	Ptr				errExceptionP;				// ErrTry,Catch exception list
	} SysAppInfoType;
typedef SysAppInfoType* SysAppInfoPtr;

Boolean SetStandardFont(UInt index);
Boolean SetFont(UInt index, VoidHand fh);

Err MySysAppStartup(SysAppInfoPtr* appInfoPP, Ptr* prevGlobalsP, Ptr* globalsPtrP)
{
DWord	value;
Err		(*oldTrap)(SysAppInfoPtr*, Ptr*, Ptr*);
Err		RetVal;
LocalID dbID;
UInt cardNo,numfonts;
char name[dmDBNameLength];
LocalID lid;
DmOpenRef dbref;
UInt i,j,count;
appFontInfo *recPtr;
VoidHand rec;

	//	Get the old trap address from HackMaster.
	FtrGet (MYCRID, trapIDSysAppStartup, &value);
    oldTrap = (Err (*)(SysAppInfoPtr*, Ptr*, Ptr*)) value;
	RetVal = oldTrap(appInfoPP,prevGlobalsP,globalsPtrP);

	if((*appInfoPP)->cmd!=sysAppLaunchCmdNormalLaunch)
		return RetVal;

	numfonts = 4;
	if(DmOpenDatabaseInfo((*appInfoPP)->dbP,&dbID,NULL,NULL,&cardNo,NULL)==0&&
		DmDatabaseInfo(cardNo, dbID, name, NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL)==0&&
		StrCompare(name,"HackMaster")==0){
		for(i=0;i<numfonts;i++)
			SetStandardFont(i);
	}

	return RetVal;
}

Boolean SetStandardFont(UInt index)
{
VoidHand fh;
void *fp;
	if((fh=DmGetResource('NFNT',0x2328+index))!=0){
		SetFont(index,fh);
		DmReleaseResource(fh);
	}
	return true;
}

Boolean SetFont(UInt index, VoidHand fh)
{
void *fp;
DWord **fonttab;
DWord *font;
DWord version;
	FtrGet(sysFtrCreator,sysFtrNumROMVersion,&version);
	if(version<0x03000000l&&index>6)return true;
	if(fh!=0 &&MemHandleLockCount(fh)!=0 &&(fp=MemHandleLock(fh))!=NULL){
		if(version<0x03000000l)
			*(((DWord *)0x1d2)+index)=(DWord)fp;
		else
			*((*((DWord **)0x1da))+index)=(DWord)fp;
//			*((*fonttab)+j)=(DWord)fp;
		MemHandleUnlock(fh);	
		return true;
	}
	return false;
}
