
#include <Pilot.h>
#include "pocketth.h"
#include "hackuidef.h"

#define MAXSTRINGS 50

Boolean FillLists();
Boolean CreateAppInfo();
Boolean SetPosition(UInt index);
Boolean CleanUp();
Boolean UpdateFontPosition(Word position, Word font);
Boolean LockFonts();
Boolean DWord2A(DWord num,char *out);

static Boolean frmMainEH(EventPtr event)
{
FormPtr form;
int handled = 0,i,j,sel;
char **strings;
VoidHand *handles,handle;
ULong count=0,version;

	switch (event->eType) {
	case frmOpenEvent:
		form = FrmGetActiveForm();
		version=0;
		FtrGet(sysFtrCreator,sysFtrNumROMVersion,&version);
		if(version<0x03000000l)
			FrmHideObject(form,FrmGetObjectIndex(form,pLargeBold));
		FillLists();
		CreateAppInfo();
		SetPosition(0);
		FrmDrawForm(form);
		handled = 1;
	break;
	case ctlSelectEvent:  // A control button was pressed and released.
		switch (event->data.ctlEnter.controlID){
		case bSave:
			FrmGotoForm(9000);
			handled = 1;
		break;
		}
	break;
	case popSelectEvent:
		if(event->data.popSelect.listID==liApplication){
			SetPosition(event->data.popSelect.selection);
		}else{
			UpdateFontPosition(event->data.popSelect.listID-liStandard,event->data.popSelect.selection);
		}
	break;
	case nilEvent:
		handled = 1;
	break;
	case frmCloseEvent:
		CleanUp();
		LockFonts();
	break;
	}

	return handled;
}

Boolean FillLists()
{
VoidHand handles[MAXSTRINGS],*rvalh,handle,vh;
LocalID dbID;
UInt cardNo,i,j,count;
DmSearchStateType dmss;
Err result;
char *strings[MAXSTRINGS], name[dmDBNameLength+6+17], buf1[dmDBNameLength+6+12], buf[20], **rval;
DmOpenRef dbref;
ULong numRec;
SWord *wchunk;
FormPtr form;

	count=0;
	strings[0]=MemPtrNew(5);
	if(strings[0]){
		StrCopy(strings[0],"none");
		handles[0]=0;
		count=1;
	}
	for(result=DmGetNextDatabaseByTypeCreator(true,&dmss,'Font',0,false,&cardNo,&dbID);
			result==0&&count<MAXSTRINGS;
			result=DmGetNextDatabaseByTypeCreator(false,&dmss,'Font',0,false,&cardNo,&dbID)){
		DmDatabaseInfo(cardNo,dbID,name,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
		dbref=DmOpenDatabase(cardNo,dbID,dmModeReadOnly);
		numRec=0;
		DmDatabaseSize(cardNo,dbID,&numRec,NULL,NULL);
		for(j=0;j<numRec;j++){
			vh=DmQueryRecord(dbref,j);
			wchunk=MemHandleLock(vh);
			if(*wchunk==0x9000){
				StrCopy(buf1,name);
				DWord2A(j,buf);
				StrCat(buf1," ");
				StrCat(buf1,buf);
				DWord2A(wchunk[7],buf);
				StrCat(buf1," h");
				StrCat(buf1,buf);
				DWord2A(wchunk[6],buf);
				StrCat(buf1," w");
				StrCat(buf1,buf);
				strings[count]=MemPtrNew(StrLen(buf1)+1);
				if(strings[count]==NULL)
					break;
				StrCopy(strings[count],buf1);
				handles[count]=vh;
				count++;
			}
			MemHandleUnlock(vh);
		}
		DmCloseDatabase(dbref);
	}
	if(!count)
		return false;
	rval=MemPtrNew(count*4);
	rvalh=MemPtrNew(count*4);
	if(rval==NULL||rvalh==NULL){
		for(i=0;i<count;i++)
			MemPtrFree(strings[i]);
		count=0;
	}
	MemMove(rval,strings,count*4);
	MemMove(rvalh,handles,count*4);
	FtrSet(kidHk,kidStrings,(DWord)rval);
	FtrSet(kidHk,kidHandles,(DWord)rvalh);
	FtrSet(kidHk,kidCount,count);

	form=FrmGetActiveForm();
	for(i=0;i<MAXFONT;i++){
		LstSetListChoices(FrmGetObjectPtr(form,FrmGetObjectIndex(form,liStandard+i)),rval,count);
	}

	return true;
}

Boolean CreateAppInfo()
{
Err result;
Long count,hcount;
DmSearchStateType dmss;
char name[dmDBNameLength];
appFontInfo afi, *recPtr;
LocalID lid, dbID;
VoidHand rec, *handles;
DmOpenRef dbref;
UInt index,cardNo,i,j,k,attr;
Boolean found,allset;
FormPtr form;
char *listChoices[MAXSTRINGS], **lc;

	found=true;
	allset=false;
	handles=NULL;
	hcount=0;
	FtrGet(kidHk,kidHandles,(DWord *)&handles);
	FtrGet(kidHk,kidCount,(DWord *)&hcount);
	if(!(lid=DmFindDatabase(0,"AppFontInfo"))){
		DmCreateDatabase(0,"AppFontInfo",kidHk,'APFI',false);
		found=false;
	}
	if((lid=DmFindDatabase(0,"AppFontInfo"))==0)
		return false;
	if((dbref=DmOpenDatabase(0,lid,dmModeReadWrite))==0)
		return false;

	if(!found){
		index=0;
		rec=DmNewRecord(dbref,&index,sizeof(appFontInfo));
		afi.appName[0]=0;
		for(i=0;i<MAXFONT;i++)
			afi.fontHand[i]=0;
		recPtr=MemHandleLock(rec);
		DmWrite(recPtr,0,&afi,sizeof(appFontInfo));
		MemHandleUnlock(rec);
		DmReleaseRecord(dbref,index,true);
	}

	count=0;
	count=DmNumRecords(dbref);
	attr=dmRecAttrSecret;
	for(i=0;i<count;i++){
		DmSetRecordInfo(dbref,i,&attr,NULL);
	}

	for(result=DmGetNextDatabaseByTypeCreator(true,&dmss,'appl',0,false,&cardNo,&dbID);
			result==0;
			result=DmGetNextDatabaseByTypeCreator(false,&dmss,'appl',0,false,&cardNo,&dbID)){
		DmDatabaseInfo(cardNo,dbID,name,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
		found=false;
		for(i=0;i<count&&!found;i++){
			if((rec=DmQueryRecord(dbref,i))==0)continue;
			if((recPtr=MemHandleLock(rec))==NULL)continue;
			if(recPtr->appName[0]==0&&!allset){
				attr=0;
				DmSetRecordInfo(dbref,i,&attr,NULL);
				allset=true;
			}
			if(StrCompare(recPtr->appName,name)==0){
				found=true;
				attr=0;
				DmSetRecordInfo(dbref,i,&attr,NULL);
			}
			MemHandleUnlock(rec);
		}
		if(!found){
			index=count;
			rec=DmNewRecord(dbref,&index,sizeof(appFontInfo));
			StrCopy(afi.appName,name);
			for(i=0;i<MAXFONT;i++)
				afi.fontHand[i]=0;
			recPtr=MemHandleLock(rec);
			DmWrite(recPtr,0,&afi,sizeof(appFontInfo));
			MemHandleUnlock(rec);
			DmReleaseRecord(dbref,index,true);
			count=DmNumRecords(dbref);
		}
	}

	DmRemoveSecretRecords(dbref);

	count=DmNumRecords(dbref);
	for(i=0;i<count;i++){
		if((rec=DmGetRecord(dbref,i))==0)break;
		if((recPtr=MemHandleLock(rec))==NULL)break;
		if(recPtr->appName[0]==0){
			listChoices[i]=MemPtrNew(4);
			StrCopy(listChoices[i],"All");
		}else{
			listChoices[i]=MemPtrNew(StrLen(recPtr->appName));
			StrCopy(listChoices[i],recPtr->appName);
		}
		for(j=0;j<MAXFONT;j++){
			if(recPtr->fontHand[j]){
				found=false;
				for(k=0;k<hcount;k++)
					if(handles[k]==recPtr->fontHand[j])
						found=true;
				if(!found){
					MemMove(&afi,recPtr,sizeof(appFontInfo));
					afi.fontHand[j]=0;
					DmWrite(recPtr,0,&afi,sizeof(appFontInfo));
				}else
					while(MemHandleLockCount(recPtr->fontHand[j])!=0)
						MemHandleUnlock(recPtr->fontHand[j]);
			}	
		}
		DmReleaseRecord(dbref,i,true);
		MemHandleUnlock(rec);
	}
	DmCloseDatabase(dbref);

	lc=MemPtrNew(count*4);
	MemMove(lc,listChoices,count*4);
	FtrSet(kidHk,kidApps,(DWord)lc);
	FtrSet(kidHk,kidAppcount,(DWord)count);
	form=FrmGetActiveForm();
	LstSetListChoices(FrmGetObjectPtr(form,FrmGetObjectIndex(form,liApplication)),lc,count);
	return true;
}

Boolean SetPosition(UInt index)
{
FormPtr form;
LocalID lid, dbID;
Long count;
DmOpenRef dbref;
UInt i,j;
VoidHand handle, *handles, rec;
appFontInfo *recPtr;
ListPtr plist;
Boolean found;
	form=FrmGetActiveForm();

	if((lid=DmFindDatabase(0,"AppFontInfo"))==0)
		return false;
	if((dbref=DmOpenDatabase(0,lid,dmModeReadOnly))==0)
		return false;

	if((rec=DmQueryRecord(dbref,index))==0)return false;
	if((recPtr=MemHandleLock(rec))==NULL)return false;
	
	plist=FrmGetObjectPtr(form,FrmGetObjectIndex(form,liApplication));
	LstSetSelection(plist,index);
	CtlSetLabel(FrmGetObjectPtr(form,FrmGetObjectIndex(form,pApplication)),LstGetSelectionText(plist,index));

	handles=NULL;
	count=0;
	FtrGet(kidHk,kidHandles,(DWord *)&handles);
	FtrGet(kidHk,kidCount,(DWord *)&count);
	if(handles!=NULL && count){
		for(i=0;i<MAXFONT;i++){
			handle=recPtr->fontHand[i];
			found=false;
			if(handle){
				for(j=0;j<count&&!found;j++){
					if(handle==handles[j]){
						plist=FrmGetObjectPtr(form,FrmGetObjectIndex(form,liStandard+i));
						LstSetSelection(plist,j);
						CtlSetLabel(FrmGetObjectPtr(form,FrmGetObjectIndex(form,pStandard+i)),LstGetSelectionText(plist,j));
						found=true;
					}
				}
			}
			if(!found)
				UpdateFontPosition(i,0);
			if(!found||!handle){
					plist=FrmGetObjectPtr(form,FrmGetObjectIndex(form,liStandard+i));
					LstSetSelection(plist,0);
					CtlSetLabel(FrmGetObjectPtr(form,FrmGetObjectIndex(form,pStandard+i)),LstGetSelectionText(plist,0));
			}
		}
	}
	MemHandleUnlock(rec);
	DmCloseDatabase(dbref);
	return true;
}

Boolean CleanUp()
{
VoidHand *handles,handle;
char **strings,**lc;
ULong count,appcount;
UInt i;
	handles=NULL;
	handle=NULL;
	strings=NULL;
	lc=NULL;
	count=0;
	appcount=0;
	FtrGet(kidHk,kidStrings,(DWord *)&strings);
	FtrGet(kidHk,kidHandles,(DWord *)&handles);
	FtrGet(kidHk,kidApps,(DWord *)&lc);
	FtrGet(kidHk,kidAppcount,(DWord *)&appcount);
	FtrGet(kidHk,kidCount,(DWord *)&count);
	FtrUnregister(kidHk,kidCount);
	if(handles!=NULL){
		FtrUnregister(kidHk,kidHandles);
		MemPtrFree(handles);
	}
	if(strings!=NULL){
		FtrUnregister(kidHk,kidStrings);
		for(i=0;i<count;i++)
			MemPtrFree(strings[i]);
		MemPtrFree(strings);
	}
	if(lc!=NULL){
		FtrUnregister(kidHk,kidApps);
		for(i=0;i<appcount;i++)
			MemPtrFree(lc[i]);
		MemPtrFree(lc);
	}
	return true;
}

Boolean UpdateFontPosition(Word position, Word font)
{
LocalID lid;
DmOpenRef dbref;
FormPtr form;
UInt appIndex;
VoidHand rec, *handles;
appFontInfo *recPtr,afi;
	form=FrmGetActiveForm();
	appIndex=LstGetSelection(FrmGetObjectPtr(form,FrmGetObjectIndex(form,liApplication)));
	handles=NULL;
	FtrGet(kidHk,kidHandles,(DWord *)&handles);
	if(appIndex==-1||handles==NULL)return false;
	if((lid=DmFindDatabase(0,"AppFontInfo"))==0)
		return false;
	if((dbref=DmOpenDatabase(0,lid,dmModeReadWrite))==0)
		return false;
	rec=DmGetRecord(dbref,appIndex);
	recPtr=MemHandleLock(rec);
	if(recPtr!=NULL){
		MemMove(&afi,recPtr,sizeof(appFontInfo));
		afi.fontHand[position]=handles[font];
		DmWrite(recPtr,0,&afi,sizeof(appFontInfo));
	}
	MemHandleUnlock(rec);
	DmReleaseRecord(dbref,appIndex,true);
	DmCloseDatabase(dbref);
	return true;
}

Boolean LockFonts()
{
LocalID lid;
DmOpenRef dbref;
UInt i,j,count;
appFontInfo *recPtr;
VoidHand rec;
	if((lid=DmFindDatabase(0,"AppFontInfo"))==0)
		return false;
	if((dbref=DmOpenDatabase(0,lid,dmModeReadOnly))==0)
		return false;
	count=0;
	count=DmNumRecords(dbref);
	for(i=0;i<count;i++){
		if((rec=DmQueryRecord(dbref,i))==0)break;
		if((recPtr=MemHandleLock(rec))==NULL)break;
		for(j=0;j<MAXFONT;j++)
			if(recPtr->fontHand[j]!=0&&MemHandleLockCount(recPtr->fontHand[j])==0)
				MemHandleLock(recPtr->fontHand[j]);
		MemHandleUnlock(rec);
	}
	DmCloseDatabase(dbref);
	return true;
}

Boolean DWord2A(DWord num,char *out)
{
UInt rem,i,max;
DWord n;
	n=num;
	if(n==0){out[0]='0';out[1]=0;return true;}
	for(i=0;n!=0;n=n/10,i++)
	max=i;
	out[max+1]=0;
	n=num;
	for(i=0;n!=0;n=n/10,i++){
		rem=n%10;
		out[max-i]=rem+'0';
	}
	return true;
}