/*
	thai.h -- thai characters
*/

#ifndef __THAI__
#define __THAI__

#define	KoreGai		(unsigned char) 0xA1	/*		*/
#define	KorKai		(unsigned char) 0xA2	/*		*/
#define	KorKuad		(unsigned char) 0xA3	/*		*/
#define	KoreKwai	(unsigned char) 0xA4	/*		*/
#define	KoreKon		(unsigned char) 0xA5	/*		*/
#define	KoreRakung	(unsigned char) 0xA6	/*		*/
#define	NgorNgoo	(unsigned char) 0xA7	/*		*/
#define	JoreJarn	(unsigned char) 0xA8	/*		*/
#define	ChorChing	(unsigned char) 0xA9	/*		*/
#define	ShoreChang	(unsigned char) 0xAA	/*		*/
#define	SoreSoe		(unsigned char) 0xAB	/*		*/
#define	ShoreKracher	(unsigned char) 0xAC	/*		*/
#define	YoreYing	(unsigned char) 0xAD	/*		*/
#define	DoreChada	(unsigned char) 0xAE	/*		*/
#define	TorePatak	(unsigned char) 0xAF	/*		*/
#define	ThorSantan	(unsigned char) 0xB0	/*		*/
#define	ToreMontoe	(unsigned char) 0xB1	/*		*/
#define	TorePootao	(unsigned char) 0xB2	/*		*/
#define	NoreNane	(unsigned char) 0xB3	/*		*/
#define	DoreDek		(unsigned char) 0xB4	/*		*/
#define	ToreTao		(unsigned char) 0xB5	/*		*/
#define	ThorToong	(unsigned char) 0xB6	/*		*/
#define	ToreTaharn	(unsigned char) 0xB7	/*		*/
#define	ToreTong	(unsigned char) 0xB8	/*		*/
#define	NoreNoo		(unsigned char) 0xB9	/*		*/
#define	BoreBaimai	(unsigned char) 0xBA	/*		*/
#define	PorePla		(unsigned char) 0xBB	/*		*/
#define	PorPeng		(unsigned char) 0xBC	/*		*/
#define	ForFa		(unsigned char) 0xBD	/*		*/
#define	PoreParn	(unsigned char) 0xBE	/*		*/
#define	ForeFun		(unsigned char) 0xBF	/*		*/
#define	PoreSumpao	(unsigned char) 0xC0	/*		*/
#define	MoreMar		(unsigned char) 0xC1	/*		*/
#define	YoreYak		(unsigned char) 0xC2	/*		*/
#define	RoreReo		(unsigned char) 0xC3	/*		*/
#define	RoreRu		(unsigned char) 0xC4	/*		*/
#define	LoreLing	(unsigned char) 0xC5	/*		*/
#define	WoreWaan	(unsigned char) 0xC7	/*		*/
#define	SoreSala	(unsigned char) 0xC8	/*		*/
#define	SoreRusi	(unsigned char) 0xC9	/*		*/
#define	SoreSeo		(unsigned char) 0xCA	/*		*/
#define	HorHeeb		(unsigned char) 0xCB	/*		*/
#define	LorChula	(unsigned char) 0xCC	/*		*/
#define	OrAng		(unsigned char) 0xCD	/*		*/
#define	HorNokHook	(unsigned char) 0xCE	/*		*/

#define	PaiYarnnoy	(unsigned char) 0xCF	/*		*/
#define	SaraAh		(unsigned char) 0xD0	/*		*/
#define	HunAkad		(unsigned char) 0xD1	/*	ѹҡ	*/
#define	SaraR		(unsigned char) 0xD2	/*		*/
#define	SaraUm		(unsigned char) 0xD3	/*		*/
#define	SaraIe		(unsigned char) 0xD4	/*		*/
#define	SaraE		(unsigned char) 0xD5	/*		*/
#define	SaraUe		(unsigned char) 0xD6	/*		*/
#define	SaraUee		(unsigned char) 0xD7	/*		*/
#define	SaraU		(unsigned char) 0xD8	/*		*/
#define	SaraUU		(unsigned char) 0xD9	/*		*/
#define	ThaiDot		(unsigned char) 0xDA	/*		*/
#define	SaraA		(unsigned char) 0xE0	/*		*/
#define	SaraAir		(unsigned char) 0xE1	/*		*/
#define	SaraO		(unsigned char) 0xE2	/*		*/
#define	MaiMuan		(unsigned char) 0xE3	/*	ǹ	*/
#define	MaiMalai	(unsigned char) 0xE4	/*		*/
#define	SaraR2	(unsigned char) 0xE5	/*	 */
#define	MaiYamok	(unsigned char) 0xE6  /*  */
#define	MaiTaiKuu	(unsigned char) 0xE7	/*		*/
#define	MaiEk		(unsigned char) 0xE8	/*	͡	*/
#define	MaiToe		(unsigned char) 0xE9	/*		*/
#define	MaiTri		(unsigned char) 0xEA	/*		*/
#define	MaiJattawa	(unsigned char) 0xEB	/*	ѵ	*/
#define	Karan		(unsigned char) 0xEC	/*	ѹ	*/
#define	ThaiSpecial1		(unsigned char) 0xED	/*  */
#define	ThaiSpecial2		(unsigned char) 0xEE	/* */

#define	_Exclamation	(unsigned char) 0x21	/* ! */
#define	_Dollar		(unsigned char) 0x24	/* $ */
#define	_Percent	(unsigned char) 0x25	/* % */
#define	_OpenParen	(unsigned char) 0x28	/* ǧԴ*/
#define	_CloseParen	(unsigned char) 0x29	/* ǧ纻Դ */
#define	_Hyphen		(unsigned char) 0x2D	/* - */
#define	_FullStop	(unsigned char) 0x2E	/* . */

#define	_Colon		(unsigned char) 0x3A
#define	_SemiColon	(unsigned char) 0x3B
#define	_Question	(unsigned char) 0x3F	/* ? */
#define	_LeftBracket	(unsigned char) 0x5B	/* [ */
#define	_RightBracket	(unsigned char) 0x5D	/* ] */
#define	_LeftBrace	(unsigned char) 0x7B	/* { */
#define	_RightBrace	(unsigned char) 0x7D	/* } */
#define	_Baht		(unsigned char) 0xDF	/* 	*/

# endif __THAI__
